package services

import (
	"context"
	"io"

	"github.com/aws/aws-sdk-go-v2/service/sqs"
	"github.com/fgm/izidic"
)

type CreateMoveTaskOutput struct {
	Status                           *string // Running
	SourceARN                        *string
	ApproximateNumberOfMessagesMoved int
}

type Redriver interface {
	CreateMoveTask()
	ListMoveTasks() []any
}

type redriver struct {
}

func (r redriver) CreateMoveTask() {
	// TODO implement me
	// u := url.URL{
	// 	Scheme:      "https",
	// 	User:        nil,
	// 	Host:        "",
	// 	Path:        "",
	// 	RawPath:     "",
	// 	OmitHost:    false,
	// 	ForceQuery:  false,
	// 	RawQuery:    "",
	// 	Fragment:    "",
	// 	RawFragment: "",
	// }
	/*
		Action=CreateMoveTask
		&SourceArn=arn%3Aaws%3Asqs%3Aeu-west-3%3A751146239996%3Atest-dlq
		&TaskName=079228fe-098b-436d-a2f4-cb4d29ebb55a
		&Version=2012-11-05
	*/
}

func (r redriver) ListMoveTasks() []any {
	// TODO implement me
	panic("implement me")
}

func RedriverService(dic *izidic.Container) (any, error) {
	cli := dic.MustService(SvcClient).(*sqs.Client)
	w := dic.MustParam(PWriter).(io.Writer)
	return func(ctx context.Context, qName string) {
		senderHandler(ctx, w, cli, qName)
	}, nil
}
